;stg0.idlprc.pro reads the datafile
;('3C286_sp_RcvrPF_1_0.6_0_09Jan22_07:38:41.sav'), defines frequencies
;and other parameters that are defined by quantities in the datafile,
;and reads the current version of coeffs_out and sigcoeffs_out if their
;file (named 'coeffs_out_3C286_839MHz_22Jan2009.sav') exists.

restore,'3C286_sp_RcvrPF_1_0.6_0_09Jan22_07:38:41.sav',/ve
sourcename= src[0].sname
freq= src[0].subscan[0].freq[0]
nchnls= src[0].nchan
nsubscans= src[0].nsubscan

;Define the baseband frequencies of the channels...
freq_bb = src[0].subscan[0].bwsign* (src[0].subscan[0].bandwdth/ 1.d6) * $
             ((dindgen( nchnls)- nchnls/2l)/ nchnls)
;Define RF frequencies of the chasnnels...
freq_rf= freq_bb+ src[0].subscan[0].freq[0]/1.d6

aprt= {srcname:sourcename, scan:0, cfr:freq}  ;used in PRTPLOT_2021.PRO
windownr=9              ;plotting window for  PRTPLOT_2021.PRO

;GENERATE THE MUELLER MATRIX FILE NAME (muellerfilename)...         
caldat, mjd2jd( src[0].mjdstart), month, day, year
muellerfilename= 'coeffs_out_' + sourcename+ '_' + $
strtrim(string(freq/1.e6, format='(i)'),1) + 'MHz_' $
+ string( day, format='(i2.2)') + monthnr2monthname(month)+ $
strtrim(year,1)+ '.sav'

;if the mueller file already exists, read it to get the             
;current version of COEFFS_OUT.                                     
fileinfo= FILE_INFO( muellerfilename)
if fileinfo.exists eq 1 then begin
   restore, muellerfilename
   print, '>>>> NOTE !!! <<<<< ' + muellerfilename +$
         ' already exists, so we are'
   print, '>>>> READING COEFFS_OUT FROM ' + MUELLERFILENAME
ENDIF

end
