;STG2_IDLPRC.PRO derives the Mueller matrix coefficients, and also the
;Mueller matrix itself M_RX, from the bandpass-integrated, normalized
;versions of measured Stokes parameters.

if keyword_set(fromstg3) then goto, fmstg3
sz= size( stki_meas)
nrchnls= sz[1]
nrspct= sz[2]
;stop
;AVERAGE OVER ALL SPECTRAL CHANNELS...
stki_meas_cont= total( stki_meas, 1)/nrchnls
stki_meas_cont= reform( stki_meas_cont, 1, nrspct)

stkq_meas_cont= total( stkq_meas, 1)/nrchnls
stkq_meas_cont= reform( stkq_meas_cont, 1, nrspct)

stku_meas_cont= total( stku_meas, 1)/nrchnls
stku_meas_cont= reform( stku_meas_cont, 1, nrspct)

stkv_meas_cont= total( stkv_meas, 1)/nrchnls
stkv_meas_cont= reform( stkv_meas_cont, 1, nrspct)

;NORMALIZE...DIVIDE BY SOURCE STOKES I. do I last!!!
stkq_meas_cont_norm= stkq_meas_cont/ stki_meas_cont
stku_meas_cont_norm= stku_meas_cont/ stki_meas_cont
stkv_meas_cont_norm= stkv_meas_cont/ stki_meas_cont
stki_meas_cont_norm= stki_meas_cont/ stki_meas_cont

fmstg3:
fromstg3=0
onoffs_to_pacoeffs, $
        parallactic_on, stki_meas_cont_norm, stkq_meas_cont_norm, $
        stku_meas_cont_norm, stkv_meas_cont_norm, sigmalimit, $
        pacoeffs, ngoodpoints=ngoodpoints

mm_coeffs_in_setup, coeffs_in
coeffs_in.src= aprt.srcname + ' ' +$
        strtrim( long( aprt.cfr/1.e6),2) + ' MHz'
;mmfit_2016, pacoeffs, coeffs_in, coeffs_out, sigcoeffs_out, /fixvsrc, $
;    nloop=nloop 

mmfit_2016_chisq, pacoeffs, coeffs_in, coeffs_out, sigcoeffs_out, $
        chisq_full=chisq_full, chisq_red=chisq_red, $
        /fixvsrc, nloop=nloop, /dochisq

if keyword_set( mueller_save) then $
   save, coeffs_out, sigcoeffs_out, file=muellerfilename

;PRINT ON THE TERMINAL WINDOW...
nrps=0
indx=0
print_stokespa_2021, indx, aprt, coeffs_out, sigcoeffs_out,$
        ngoodpoints, nloop
title= aprt.srcname + '_FREQ_' + $
        strtrim( long(string(aprt.cfr/1.e6)), 2) + ' chisq'; $
;        '_' + strtrim( muellerchk, 2)

;PLOT AND PRINT THE RESULTS ON X PLOTTING WINDOW
prtplot_2021, nrps, windownr, indx, aprt, coeffs_out, sigcoeffs_out, $
        parallactic_on, stki_meas_cont_norm, stkq_meas_cont_norm, $
   stku_meas_cont_norm, stkv_meas_cont_norm, $
        pacoeffs, ngoodpoints, $
         title=title

;PLOT AND PRINT THE RESULTS ON PS FILE IF SO DESIRED...
if keyword_set( ps1yes) then begin
nrps=1
prtplot_2021, nrps, windownr, indx, aprt, coeffs_out, sigcoeffs_out, $
        parallactic_on, stki_meas_cont_norm, stkq_meas_cont_norm, $
   stku_meas_cont_norm, stkv_meas_cont_norm, $
        pacoeffs, ngoodpoints, $
        title=title, path=outpath, plotfilename=title 
endif

end
