;+
;STG3_IDLPRC.PRO applies Mueller matrix MM_RX with options to apply one
;or both of MM_RHO_X and MM_TEL_IAU.
;
;INPUTS:
;COEFFS_OUT, the structure containning the MM_RX coefficients (from the
;       file MUELLERFILENAME, produced by STG2.IDLPRC.PRO)
;STKI_MEAS[NRCHNLS, NRPOS], the array of Stokes I (nr of spectral
;       channels, the nr of spectra)
;STKQ_MEAS[NRCHNLS, NRPOS]. as for I
;STKU_MEAS[NRCHNLS, NRPOS]. as for I
;STKV_MEAS[NRCHNLS, NRPOS]. as for I
;mm_tel_iau, the 
;KEYWORDS:
;M_RHO_X: if this keyword is not set, only the MM_RX correction is
;       applied. If set, then MM_RHO_X is also applied
;M_TEL-IAU: if this keyword is not set, only the MM_RX correction is
;       applied. If set, then MM_TEL-IAU is also applied
;MM_TEL-IAU: you need to specify MM_TEL_IAU only if M_TEL_IAU is set.
;
;OUTPUT:
;STOKESOUT, the corrected stokes vector
;-

;MMCORR uses a 3-d stokes array as input, not arrays of the separate
;       Stokes parameters, so make the array:
   stokesmeas= fltarr( 1, 4, nrspct)
   stokesmeas[ 0,0,*]= stki_meas_cont_norm
   stokesmeas[ 0,1,*]= stkq_meas_cont_norm
   stokesmeas[ 0,2,*]= stku_meas_cont_norm
   stokesmeas[ 0,3,*]= stkv_meas_cont_norm

;   m_rho_x=0
;   if muellerchk eq 2 then m_rho_x=1
;   m_tel_iau=0
;   cfr=8.395e8
   mm_rx= coeffs_out.m_tot
   mmcorr, mm_rx, mm_tel_iau, parallactic_on, stokesmeas, stokesout, $
        m_rho_x=m_rho_x, m_tel_iau= m_tel_iau
;   stki_uncal_cont_norm= stokescal[ 0,0,*]
;   stkq_uncal_cont_norm= stokescal[ 0,1,*]
;   stku_uncal_cont_norm= stokescal[ 0,2,*]
;   stkv_uncal_cont_norm= stokescal[ 0,3,*]
   
stki_meas_cont_norm= stokesout[ 0,0,*]
stkq_meas_cont_norm= stokesout[ 0,1,*]
stku_meas_cont_norm= stokesout[ 0,2,*]
stkv_meas_cont_norm= stokesout[ 0,3,*]

fromstg3=1

end
