
; FUNdamental Physical Constants
k    = 1.380658d-16     ; erg K-1
G    = 6.67259d-8       ; g-1 cm3 s-2
c    = 2.99792458d10    ; cm s-1
h    = 6.6260755d-27    ; erg s
sbc  = 5.67051d-5	; erg cm-2 K-4 s-1
arad = 7.56591d-15	; erg cm-3 K-4 
mh   = 1.673d-24	; g
amu  = 1.6605402d-24    ; g
hbar = h/(2*!dpi)	; erg s
me   = 9.1093898d-28    ; g
qe   = 4.80321d-10      ; esu


; SOLAR CONSTANTS
Msun = 1.989d33         ; g
Rsun = 6.96d10          ; cm
Lsun = 3.847d33		; erg s-1

; TIME/DISTANCE/ENERGY CONVERSIONS
AU   = 1.495979d13 	; cm
pc   = 3.085678d18	; cm
ly   = 9.46053d17	; cm
yr   = 3.155693d7	; s
eV   = 1.60217733d-12	; erg

; FLUX
jy = 1d-23		; erg s-1 cm-2 Hz-1
