
;before invoking this text file, define the environment variable
;$RHSTK_2021CORE as the subdirectory where you have de-tarred
;idlprocs_rhstk_202.tar

!path= expand_path( getenv('RHSTK_2021CORE') + 'gen/path/') + ':' + !path
;addpath, getenv('RHSTK_2021CORE') + 'CodeIDL'
addpath, getenv('RHSTK_2021CORE')  + 'goddard_jan2007', /expand
;addpath, getenv('RHSTK_2021CORE')  + 'idlutils', /expand
addpath, getenv('RHSTK_2021CORE')  + 'gen', /expand
addpath, getenv('RHSTK_2021CORE')  + 'dzd4_rhstk_2021/procs'
addpath, getenv('RHSTK_2021CORE')  + 'dzd4_rhstk_2021/procs/calib'
addpath, getenv('RHSTK_2021CORE')  + 'dzd4_rhstk_2021/procs/mueller_2016'

;OBSERVATORY COORDINATES...                                                    ;these are for Arecibo...                                                      print, 'loading ARECIBO coordinates into COMMON ANGLESTUFF'
common anglestuff, obslong, obslat, cosobslat, sinobslat
obslong = ten(66,45,10.8)
obslat = ten(18,21,14.2)
cosobslat = cos(!dtor*obslat)
sinobslat = sin(!dtor*obslat)
defsysv, '!obsnlat', obslat
defsysv, '!obselong', 360.d0- obslong
defsysv, '!obswlong', obslong

; WE'RE GOING TO SET THE PLOT DEVICE TO X WINDOWS...
set_plot, 'X'
; SET THE NUMBER OF LINES YOU WANT IDL TO SAVE FOR UP-ARROW CALLBACK...
!EDIT_INPUT=200
; LET OPERATING SYSTEM TAKE CARE OF BACKING STORE...
device, RETAIN=2

; Set color decomposition OM ('millions of colors'
device, decomposed=1
setcolors, /SYSTEM_VARIABLES, /silent
;DEFSYSV, '!grey', !grey

print, ''
print, 'We define the following colors: ', $
               '!black , ',  $
               '!red , ' ,   $
               '!orange , ', $
               '!green , ' ,  $
               '!forest , ', $
               '!yellow , ', $
               '!cyan , ',   $
               '!blue , ',   $
               '!magenta , ',$
               '!purple , ', $
               '!gray, ',   $
               '!white'

print, 'and WE DEFINE THE VECTOR !pcolr, which contains 10 of the above colors that are useful in most plots'
defsysv, '!pcolr', [!gray, !red, !green, !blue, !yellow, !magenta, !cyan, $
        !orange, !forest, !purple]
 
; SET THE CURSOR TO A THIN CROSS (33) 
print, 'Set the cursor to an arrow pointer (46)'
defsysv, '!cursor_standard', 46
device, CURSOR_STANDARD=!cursor_standard

;Open a window:
window, 0, xsize=300, ysize=225, retain=2

; BELOW I'M REDEFINING SOME KEY COMBINATIONS...
print, 'We define the following key controls:'
define_key, /control, '^F', /forward_word
print, 'Defining CTRL-F : Move cursor forward one word'
define_key, /control, '^B', /back_word
print, 'Defining CTRL-B : Move cursor backward one word'
define_key, /control, '^K', /delete_eol
print, 'Defining CTRL-K : Delete to end of line'
define_key, /control, '^U', /delete_line
print, 'defining CTRL-U : Delete to beginning of line'
define_key, /control, '^D', /delete_current
print, 'Defining CTRL-D : Delete current character under cursor'
define_key, /control, '^W', /delete_current
print, 'Defining CTRL-W : Delete word to left of cursor'
print, 'Defining CTRL-A : Move cursor to beginning of line'
print, 'Defining CTRL-E : Move cursor to end of line'

print, ''
print, 'Successfully execuated idlstartup_rhstk_2021.idl.pro'
print, ''
